<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="emailNotificationQueryBo.prodEmailNotificationBo">
            <el-row>
              <el-form-item label="渠道" prop="salesChannel" label-width="200px">
                <el-select
                  v-model="emailNotificationQueryBo.prodEmailNotificationBo.salesChannel"
                  placeholder="渠道"
                  style="width: 240px"
                  clearable
                  @keyup.enter="handleQuery"
                >
                  <el-option v-for="dict in sales_channel" :key="dict.value" :label="dict.label" :value="dict.value" />
                </el-select>
              </el-form-item>
              <el-form-item label="接收人姓名" prop="recipientName" label-width="200px">
                <el-input
                  v-model="emailNotificationQueryBo.prodEmailNotificationBo.recipientName"
                  placeholder="请输入接收人姓名"
                  style="width: 240px"
                  clearable
                  @keyup.enter="handleQuery"
                />
              </el-form-item>
              <el-form-item label="接收人邮箱" prop="recipientEmail" label-width="200px">
                <el-input
                  v-model="emailNotificationQueryBo.prodEmailNotificationBo.recipientEmail"
                  placeholder="请输入接收人邮箱"
                  style="width: 240px"
                  clearable
                  @keyup.enter="handleQuery"
                />
              </el-form-item>
            </el-row>
            <el-row>
              <el-form-item>
                <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
                <el-button icon="Refresh" @click="resetQuery">重置</el-button>
              </el-form-item>
              <el-row :gutter="10" class="mb8">
                <el-col :span="1.5">
                  <el-button v-hasPermi="['product:note:add']" type="primary" plain icon="Plus" style="margin-left: 10px" @click="handleAdd">
                    新增
                  </el-button>
                </el-col>
                <el-col :span="1.5">
                  <el-button v-hasPermi="['product:note:remove']" type="danger" plain icon="Delete" @click="handleDelete()">删除</el-button>
                </el-col>
                <!--                <el-col :span="1.5">-->
                <!--                  <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['print:emailNotification:export']"-->
                <!--                    >导出模板-->
                <!--                  </el-button>-->
                <!--                </el-col>-->
                <el-col :span="1.5">
                  <el-button v-hasPermi="['product:note:import']" type="danger" plain icon="Upload" @click="handleImport">导入</el-button>
                </el-col>
                <!--                <el-col :span="1.5">-->
                <!--                  <el-dropdown-item icon="Top" @click="handleImport"> 导入数据</el-dropdown-item>-->
                <!--                </el-col>-->
              </el-row>
            </el-row>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <el-table v-loading="loading" :data="emailNotificationList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="渠道" align="center" prop="salesChannel">
          <template #default="scope">
            <dict-tag :options="sales_channel" :value="scope.row.salesChannel" />
          </template>
        </el-table-column>
        <el-table-column label="接收人姓名" align="center" prop="recipientName" />
        <el-table-column label="接收人邮箱" align="center" prop="recipientEmail" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button v-hasPermi="['product:note:edit']" link type="primary" icon="Edit" @click="handleUpdate(scope.row)"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button v-hasPermi="['product:note:remove']" link type="primary" icon="Delete" @click="handleDelete(scope.row)"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination
        v-show="total > 0"
        v-model:page="emailNotificationQueryBo.pageQuery.pageNum"
        v-model:limit="emailNotificationQueryBo.pageQuery.pageSize"
        :total="total"
        @pagination="getList"
      />
    </el-card>
    <!-- 添加或修改邮件通知接收人配置对话框 -->
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="500px" append-to-body>
      <el-form ref="emailNotificationFormRef" :model="form" :rules="rules" label-width="150px">
        <el-form-item label="渠道" prop="salesChannel">
          <el-select v-model="form.salesChannel" placeholder="渠道" clearable>
            <el-option v-for="dict in sales_channel" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="接收人姓名" prop="recipientName">
          <el-input v-model="form.recipientName" placeholder="请输入接收人姓名" />
        </el-form-item>
        <el-form-item label="接收人邮箱" prop="recipientEmail">
          <el-input v-model="form.recipientEmail" placeholder="请输入接收人邮箱" />
        </el-form-item>
        <el-form-item label="备注信息" prop="remarks">
          <el-input v-model="form.remarks" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>

    <el-dialog v-model="upload.open" :title="upload.title" width="400px" append-to-body>
      <el-upload
        ref="uploadRef"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <el-icon class="el-icon--upload">
          <i-ep-upload-filled />
        </el-icon>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <template #tip>
          <div class="text-center el-upload__tip">
            <span>仅允许导入xls、xlsx格式文件。</span>
            <el-link
              v-hasPermi="['product:note:import']"
              type="primary"
              :underline="false"
              style="font-size: 12px; vertical-align: baseline"
              @click="importTemplate"
              >下载模板
            </el-link>
          </div>
        </template>
      </el-upload>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitFileForm">确 定</el-button>
          <el-button @click="upload.open = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="EmailNotification" lang="ts">
import { listEmailNotification, getEmailNotification, delEmailNotification, addEmailNotification, updateEmailNotification } from '@/api/product/note';
import { EmailNotificationVO, EmailNotificationQuery, EmailNotificationForm } from '@/api/product/note/types';
import {globalHeaders, globalUploadHeaders} from '@/utils/request';
import type { UploadFile } from 'element-plus';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const emailNotificationList = ref<EmailNotificationVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(false);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const emailNotificationFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
//字典转换
const { email_notice, sales_status, sales_intitution, sales_channel, system, prod_application_status, sys_from_system } = toRefs<any>(
  proxy?.useDict('email_notice', 'sales_status', 'sales_intitution', 'sales_channel', 'system', 'prod_application_status', 'sys_from_system')
);

// 用户导入参数
const upload = reactive({
  // 是否显示弹出层（用户导入）
  open: false,
  // 弹出层标题（用户导入）
  title: '',
  // 是否禁用上传
  isUploading: false,
  // 是否更新已经存在的用户数据
  updateSupport: 0,
  // 设置上传的请求头部
  headers: globalUploadHeaders(),
  // 上传的地址
  url: import.meta.env.VITE_APP_BASE_API + '/product/note/importData'
});

const uploadRef = ref(); // 上传组件引用
const initFormData: EmailNotificationForm = {
  notificationId: undefined,
  salesChannel: undefined,
  recipientName: undefined,
  recipientEmail: undefined,
  status: undefined,
  remarks: undefined
};
const data = reactive<PageData<EmailNotificationForm, EmailNotificationQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    salesChannel: undefined,
    recipientName: undefined,
    recipientEmail: undefined,
    status: undefined,
    remarks: undefined,
    params: {}
  },
  rules: {
    notificationId: [{ required: true, message: '配置编码不能为空', trigger: 'blur' }],
    salesChannel: [{ required: true, message: '归属渠道不能为空', trigger: 'blur' }],
    recipientName: [
      { required: true, message: '接收人姓名不能为空', trigger: 'blur' },
      {
        validator: (rule, value, callback) => {
          if (/[`~!@#$%^&*()_+<>?:"{},\/;'[\]]/im.test(value)) {
            callback(new Error('姓名不能包含特殊字符'));
          } else {
            callback();
          }
        },
        trigger: 'blur'
      }
    ],
    recipientEmail: [
      {
        required: true,
        message: '接收人邮箱是必录项，请手动录入',
        trigger: 'blur'
      },
      {
        validator: function (rule, value, callback) {
          if (value && !value.endsWith('@ydthlife.sgcc.com.cn')) {
            callback(new Error('接收人邮箱后缀必须为 @ydthlife.sgcc.com.cn'));
          } else {
            callback();
          }
        },
        trigger: 'blur'
      }
    ],
    status: [{ required: true, message: '状态不能为空', trigger: 'change' }],
    remarks: [
      {
        max: 100,
        message: '备注长度不可超过100个汉字',
        trigger: 'blur'
      }
    ]
  }
});

const { queryParams, form, rules } = toRefs(data);

const emailNotificationQueryBo = ref({
  pageQuery: {
    pageNum: 1,
    pageSize: 10
  },
  prodEmailNotificationBo: {
    salesChannel: undefined,
    recipientName: undefined,
    recipientEmail: undefined
  }
});
/** 查询邮件通知接收人配置列表 */
const getList = async () => {
  loading.value = true;
  await listEmailNotification(emailNotificationQueryBo.value)
    .then((res) => {
      emailNotificationList.value = res.rows;
      total.value = res.total;
      loading.value = false;
    })
    .catch((err) => {
    });
};
const getChannelName = (channelCode) => {
  switch (channelCode) {
    case 'G':
      return '团险渠道';
    case 'I':
      return '个险渠道';
    case 'B':
      return '银保渠道';
    default:
      return channelCode;
  }
};
/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  emailNotificationFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: EmailNotificationVO[]) => {
  ids.value = selection.map((item) => item.notificationId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加邮件通知接收人配置';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: EmailNotificationVO) => {
  reset();
  const _notificationId = row?.notificationId || ids.value[0];
  const res = await getEmailNotification(_notificationId);
  Object.assign(form.value, res);
  dialog.visible = true;
  dialog.title = '修改邮件通知接收人配置';
};

/** 提交按钮 */
const submitForm = () => {
  emailNotificationFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.notificationId) {
        await updateEmailNotification(form.value)
          .then((res) => {
            if (res === true) {
              proxy?.$modal.msgSuccess('操作成功');
            }
          })
          .catch((error) => {
          })
          .finally(() => (buttonLoading.value = false));
      } else {
        await addEmailNotification(form.value)
          .then((res) => {
            if (res === true) {
              proxy?.$modal.msgSuccess('操作成功');
            }
          })
          .catch((error) => {
          })
          .finally(() => (buttonLoading.value = false));
      }
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: EmailNotificationVO) => {
  if (!row && ids.value.length === 0) {
    proxy?.$modal.alert('请选择要删除的配置信息');
    return;
  }
  const _notificationIds = row?.notificationId || ids.value;
  await proxy?.$modal.confirm('是否确认删除邮件通知接收人配置编号为"' + _notificationIds + '"的数据项？').finally(() => (loading.value = false));
  await delEmailNotification(_notificationIds);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 下载模板 */
const importTemplate = () => {
  proxy?.download('product/note/importTemplate', {}, `产品接收人导入模版_${new Date().getTime()}.xlsx`);
};

/** 导入按钮操作 */
const handleImport = () => {
  upload.title = '导入邮件通知接收人配置';
  upload.open = true;
};

/**文件上传中处理 */
const handleFileUploadProgress = () => {
  upload.isUploading = true;
};

/** 文件上传成功处理 */
const handleFileSuccess = (response: any, file: UploadFile) => {
  upload.open = false;
  upload.isUploading = false;
  uploadRef.value?.handleRemove(file);
  ElMessageBox.alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + '</div>', '导入结果', {
    dangerouslyUseHTMLString: true
  });
  getList();
};
/** 提交上传文件 */
function submitFileForm() {
  uploadRef.value?.submit();
}

onMounted(() => {
  getList();
});
</script>
